package cn.com.infosec.jce.provider;

import cn.com.infosec.asn1.ASN1InputStream;
import cn.com.infosec.asn1.ASN1OutputStream;
import cn.com.infosec.asn1.DEREncodable;
import cn.com.infosec.asn1.DERObjectIdentifier;
import cn.com.infosec.jce.interfaces.PKCS12BagAttributeCarrier;
import java.io.ByteArrayOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

class PKCS12BagAttributeCarrierImpl implements PKCS12BagAttributeCarrier {
   private Hashtable pkcs12Attributes;
   private Vector pkcs12Ordering;

   PKCS12BagAttributeCarrierImpl(Hashtable attributes, Vector ordering) {
      this.pkcs12Attributes = attributes;
      this.pkcs12Ordering = ordering;
   }

   public PKCS12BagAttributeCarrierImpl() {
      PKCS12BagAttributeCarrierImpl var10000 = this;
      Hashtable var2;
      var2 = new Hashtable.<init>();
      Vector var1;
      var1 = new Vector.<init>();
      var10000.<init>(var2, var1);
   }

   public void setBagAttribute(DERObjectIdentifier oid, DEREncodable attribute) {
      if (this.pkcs12Attributes.containsKey(oid)) {
         this.pkcs12Attributes.put(oid, attribute);
      } else {
         this.pkcs12Attributes.put(oid, attribute);
         this.pkcs12Ordering.addElement(oid);
      }

   }

   public DEREncodable getBagAttribute(DERObjectIdentifier oid) {
      return (DEREncodable)this.pkcs12Attributes.get(oid);
   }

   public Enumeration getBagAttributeKeys() {
      return this.pkcs12Ordering.elements();
   }

   int size() {
      return this.pkcs12Ordering.size();
   }

   Hashtable getAttributes() {
      return this.pkcs12Attributes;
   }

   Vector getOrdering() {
      return this.pkcs12Ordering;
   }

   public void writeObject(ObjectOutputStream out) {
      if (this.pkcs12Ordering.size() == 0) {
         Hashtable var6;
         var6 = new Hashtable.<init>();
         out.writeObject(var6);
         Vector var7;
         var7 = new Vector.<init>();
         out.writeObject(var7);
      } else {
         ByteArrayOutputStream var2;
         var2 = new ByteArrayOutputStream.<init>();
         ASN1OutputStream var3;
         var3 = new ASN1OutputStream.<init>(var2);
         Enumeration var4 = this.getBagAttributeKeys();

         while(var4.hasMoreElements()) {
            DERObjectIdentifier var5;
            var3.writeObject(var5 = (DERObjectIdentifier)var4.nextElement());
            var3.writeObject(this.pkcs12Attributes.get(var5));
         }

         out.writeObject(var2.toByteArray());
      }

   }

   public void readObject(ObjectInputStream in) {
      Object var2;
      if ((var2 = in.readObject()) instanceof Hashtable) {
         this.pkcs12Attributes = (Hashtable)var2;
         this.pkcs12Ordering = (Vector)in.readObject();
      } else {
         ASN1InputStream in1;
         in1 = new ASN1InputStream.<init>((byte[])var2);

         DERObjectIdentifier var4;
         while((var4 = (DERObjectIdentifier)in1.readObject()) != null) {
            this.setBagAttribute(var4, in1.readObject());
         }
      }

   }
}
